//Lab_Batch 2_41
#include <iostream>
#include <cassert>
#include <string>
#include <cstring>
#include <cmath>
#include <cstdio>
#include "ezwin.h"
#include "bitmap.h"
#include "rect.h"
#include "../fparser4.4.3/fparser.cc"
#define pi 3.1415926535

using namespace std;

//All Global Declarations and initialisers

//W1

SimpleWindow W1("Input Window",28.0,20.0,Position(0.0,0.0));
BitMap Image_W1[40];
string output_W1="", name1_W1[40];
int size_W1[40], size1_W1[100];

//W2

SimpleWindow W2("Angles",11.0,19.0,Position(2.0,2.0));
BitMap Image_W2[40];
string output_W2[2]={"",""}, name1_W2[40];
int size_W2[40], size1_W2[100];

//W3

SimpleWindow W3("The Graph",22.0,21.0,Position(0.0,0.0));
float alp=45,bet=45;
char output_str[20];

//W4

SimpleWindow W4("Info",6,21.0,Position(22.5,0.0));
float X1,Y1,Z1,Xnew,Ynew,Znew;
BitMap New(W4);
BitMap Exit(W4);

//Click functions

int i=0,k=0;


//Prototypes of all functions

void OpenW1();
void OpenW2();
void OpenW3();
void OpenW4();
int Click_W1(const Position &p);
int Click_W2(const Position &p);
int Click_W4(const Position &p);
double f(string str,float x,float y);
int Extrema(string STR,float x,float y);



//-------------------------Main Function------------------------


int ApiMain()
{

	OpenW1();
	return 0;
	
}


//-------------------------/Main Function-----------------------



//-------------------------Open Window Functions----------------


void OpenW1()
{

	int j_W1=0, k_W1=0, i_W1=0;//k_W1 is the index of the bitmap
	float a_W1=1.0, b_W1=8.0;//Position of bitmap
 	char line_W1[300], name_W1[10], location_W1[30];
	string location1_W1;

	W1.Open();
	assert(W1.GetStatus() == WindowOpen);

	BitMap BackGd(W1);
	BackGd.Load("background1.xpm");
	assert(BackGd.GetStatus() == BitMapOkay);
	BackGd.SetPosition(Position(0,0));
	BackGd.Draw();


	W1.Erase(Position(5,6),18,0.5);
	

	//Taking Bitmap inputs from "buttons.txt"

	FILE * fp_W1;
	fp_W1=fopen("buttons.txt","r");
	fgets(line_W1,299,fp_W1);
	
	
	while(!feof(fp_W1))
	{
		while((name_W1[i_W1++]=line_W1[j_W1++])!=',');
		
		name_W1[i_W1-1]='\0';
		i_W1=0;
		
		while((location_W1[i_W1++]=line_W1[j_W1++])!='\n');
		
		location_W1[i_W1-2]='\0';
		name1_W1[k_W1]=name_W1; location1_W1=location_W1; size_W1[k_W1]=strlen(name_W1);
		i_W1=j_W1=0;
		
		Image_W1[k_W1].SetWindow(W1);
		Image_W1[k_W1].Load(location1_W1);
		assert(Image_W1[k_W1].GetStatus() == BitMapOkay);
		Image_W1[k_W1].SetPosition(Position(a_W1,b_W1));
		Image_W1[k_W1].Draw();
		
		k_W1++;

		//Arrangements done so as to get the required bitmaps in required positions
		
		if(k_W1==33){a_W1+=3.5;b_W1=16;}
		
		else if(a_W1<=24&&k_W1!=34)a_W1+=3.5;
		
		else if(k_W1==34)
		{
			a_W1=11.5;
		}
		
		else
		{
			b_W1+=2;
			a_W1=1;
		}
		
		fgets(line_W1,299,fp_W1);
		
	}

	fclose(fp_W1);
	
	W1.SetMouseClickCallback(Click_W1);
	
}


int flag=0;int abc=0;


void OpenW2()
{

	W2.Open();
	
	flag=0;abc=0;
	int j_W2=0, k_W2=0 ,i_W2=0;//k_W2 is the index of the bitmap
	float a_W2=1.0, b_W2=9.0;//position of bitmap
 	char line_W2[300], name_W2[10], location_W2[30];
	string location1_W2;

	BitMap BackGd2(W2);
	BackGd2.Load("background2.xpm");
	BackGd2.SetPosition(Position(0,0));
	BackGd2.Draw();
	
	W2.Erase(Position(1.5,7),8,0.5);
	
	output_W2[0]="";
	output_W2[1]="";
	
	alp=45;bet=45;//Initialising to isometric view
	
	//Taking Bitmap inputs from angles.txt
	
	FILE * fp_W2;
	fp_W2=fopen("angles.txt","r");
	fgets(line_W2,299,fp_W2);
	
	
	while(!feof(fp_W2))
	{
	
		while((name_W2[i_W2++]=line_W2[j_W2++])!=' ');
		name_W2[i_W2-1]='\0';
		i_W2=0;
		
		while((location_W2[i_W2++]=line_W2[j_W2++])!='\n');
		
		location_W2[i_W2-2]='\0';
		name1_W2[k_W2]=name_W2; location1_W2=location_W2; size_W2[k_W2]=strlen(name_W2);
		i_W2=j_W2=0;
		
		Image_W2[k_W2].SetWindow(W2);
		Image_W2[k_W2].Load(location1_W2);
		assert(Image_W2[k_W2].GetStatus() == BitMapOkay);
		Image_W2[k_W2].SetPosition(Position(a_W2,b_W2));
		Image_W2[k_W2].Draw();
		
		k_W2++;

		//Arrangements done so as to get the required bitmaps in required positions
		
		if(a_W2<=5)a_W2+=3.5;
		
		else
		{
			b_W2+=2;
			a_W2=1;
		}
		
		fgets(line_W2,299,fp_W2);
		
	}

	fclose(fp_W2);
	
	W2.SetMouseClickCallback(Click_W2);
	
}	


void OpenW3()
{
		
	W3.Open();
	
	
	float b_W3=0.5;
	int a,b,d=1,j=1,k=1,l=1;
	a=0;
	float x,y,z,x1,y1;
	

	//Taking the input angles from W2 in degrees and converting into radians
	
	stringstream ss1 (stringstream::in | stringstream::out);
  	ss1 << output_W2[0];
 	ss1 >> alp;  
 	
	stringstream ss2 (stringstream::in | stringstream::out);
  	ss2 << output_W2[1];
  	ss2 >> bet;
	
	alp=alp*(pi)/180;
	bet=bet*(pi)/180;
	
	
	int lim1=-5,lim2=5;
	
	//Points derived from the transformation Equations mentioned below

	//Original Y-Axis
	
	for(y=-15;y<15;y+=0.031)
	{
		RectangleShape Ry(W3,Position(y*sin(alp)+10,10-y*cos(alp)*cos(bet)),Red,0.05,0.05);
		Ry.ClearBorder();
		Ry.Draw();
	}

	//Original X-Axis
	
	for(x=-15;x<15;x+=0.031)
	{
		RectangleShape Rx(W3,Position(x*cos(alp)+10,10+x*sin(alp)*cos(bet)),Blue,0.05,0.05);
		Rx.ClearBorder();
		Rx.Draw();
	}
	
	//Original Z-axis
	
	for(z=-15;z<15;z+=0.031)
	{
		RectangleShape Rz(W3,Position(10,10+z*sin(bet)),Green,0.05,0.05);
		Rz.ClearBorder();
		Rz.Draw();
	}

	
	for(x1=lim1;x1<lim2;x1=x1+0.031)
	{
		
		for(y1=lim1;y1<lim2;y1=y1+0.031)
		{
		
	     	X1=x1;
			Y1=y1;
			Z1=f(output_W1,x1,y1);

			//Formule to transform into new system such that new z-axis is parallel to line of sight
			
			Xnew=(X1*cos(alp))+(Y1*sin(alp));
			Ynew=(Y1*cos(alp))-(X1*sin(alp));
			Y1=Ynew;
			Ynew=(Y1*cos(bet))+(Z1*sin(bet));
			Znew=(Y1*cos(bet))+(Z1*sin(bet));

			//Plotting the graph
			
			RectangleShape R(W3,Position(Xnew+10,10-Ynew),Black,0.1,0.1);
			R.ClearBorder();
			R.Draw();
			
			/*int Ext=Extrema(output_W1,x1,y1);
			//commented out as there are many functions with infinite no. of critical points
			//e.g z=sin(x)

			switch (Ext)
			{
				case 1:
				{
					sprintf(s1x,"%f",x1);
					sprintf(s1y,"%f",y1);
					str1x[i]=s1x;
					str1y[i]=s1y;
					j++;
					break;
				}
				case 2:
				{
					sprintf(s2x,"%f",x1);
					sprintf(s2y,"%f",y1);
					str2x[i]=s2x;
					str2y[i]=s2y;
					k++;
					break;
				}
				case 3:
				{
					sprintf(s3x,"%f",x1);
					sprintf(s3y,"%f",y1);
					str3x[i]=s3x;
					str3y[i]=s3y;
					l++;
					break;
				}
				case 0:
				{
					break;
				}
				default:
				{
					break;
				}
			}*/

		}
	
	}
	
	//Plotting every one point of ten so as to get a picture of the surface,i.e 3D effect
	
	for(x1=lim1;x1<lim2;x1=x1+0.031)
	{
		
		for(y1=lim1;y1<lim2;y1=y1+0.031,d++)
		{
		
			if(d%10==0){
				X1=x1;
				Y1=y1;
				Z1=f(output_W1,x1,y1);
				Xnew=(X1*cos(alp))+(Y1*sin(alp));//For new Y-axis,Xnew=Y1*sin(alp),Ynew=Y1*cos(alp)*cos(bet);
				Ynew=(Y1*cos(alp))-(X1*sin(alp));//For new X-axis,Xnew=X1*cos(alp),Ynew=-X1*sin(alp)*cos(bet);
				Y1=Ynew;
				Ynew=(Y1*cos(bet))+(Z1*sin(bet));
				Znew=(Y1*cos(bet))+(Z1*sin(bet));

				RectangleShape R(W3,Position(Xnew+10,10-Ynew),Yellow,0.02,0.02);
				R.ClearBorder();
				R.Draw();
				
			}

		}

	}
	
	
	/*//Rendering Extremas on W4

	for(i=1;i<j;i++)
	{
		W4.RenderText(Position(1,b_W3),Position(5,b_W3+0.5),"("+str1x[i]+","+str1y[i]+")");
		b_W3+=0.5;
	}
	W4.RenderText(Position(1,b_W3),Position(5,b_W3+0.5),str2x[0]+str2y[0]);
	b_W3+=0.5;
	for(i=1;i<k;i++)
	{
		W4.RenderText(Position(1,b_W3),Position(5,b_W3+0.5),"("+str2x[i]+","+str2y[i]+")");
		b_W3+=0.5;
	}
	W4.RenderText(Position(1,b_W3),Position(5,b_W3+0.5),str3x[0]+str3y[0]);
	b_W3+=0.5;
	for(i=1;i<l;i++)
	{
		W4.RenderText(Position(1,b_W3),Position(5,b_W3+0.5),"("+str3x[i]+","+str3y[i]+")");
		b_W3+=0.5;
	}*/

}

void OpenW4()
{

	W4.Open();
	New.Load("buttons/New.xpm");
	assert(New.GetStatus() == BitMapOkay);
	New.SetPosition(Position(1.25,18));
	New.Draw();

	Exit.Load("buttons/Exit.xpm");
	assert(Exit.GetStatus() == BitMapOkay);
	Exit.SetPosition(Position(2,19.5));
	Exit.Draw();
	W4.SetMouseClickCallback(Click_W4);
	
	
	W4.RenderText(Position(1,8),Position(3,10),"Current function:");
	W4.RenderText(Position(0,9),Position(6,11),output_W1);
	
	RectangleShape Rx1(W4,Position(1,12),Blue,1,0.1);
	Rx1.ClearBorder();
	Rx1.Draw();
	
	RectangleShape Ry1(W4,Position(1,13),Red,1,0.1);
	Ry1.ClearBorder();
	Ry1.Draw();
	
	RectangleShape Rz1(W4,Position(1,14),Green,1,0.1);
	Rz1.ClearBorder();
	Rz1.Draw();
	
	
	W4.RenderText(Position(2,11.5),Position(3.5,12.5),"x-axis");
	
	W4.RenderText(Position(2,12.5),Position(3.5,13.5),"y-axis");
	
	W4.RenderText(Position(2,13.5),Position(3.5,14.5),"z-axis");
	
	int j=1,k=1,l=1;	
	
}


//-------------------------/Open Window Functions---------------





//-------------------------Click Functions----------------------


int Click_W1(const Position &p)
{

	int k;
	
	for(k=0;k<39;k++)
	{
	
		if(Image_W1[k].IsInside(p))
		{
		
			if(k!=33&&k!=26&&k!=32)
			{
			
				output_W1=output_W1+name1_W1[k];
				W1.Erase(Position(5,6),18,0.5);
				W1.RenderText(Position(5,6),Position(23,6.5),output_W1);
				size1_W1[i]=size_W1[k];
				i++;
				
			}
			
			
			else if(k==26&&i!=0)
			{
				output_W1.erase(output_W1.end()-size1_W1[i-1],output_W1.end());i=i-1;
				W1.Erase(Position(5,6),18,0.5);
				W1.RenderText(Position(5,6),Position(23,6.5),output_W1);
				
			}
			
			
			else if(k==33&&output_W1!="")
			{
				W1.Close();
				OpenW2();
			}
			
			
			else if(k==32)
			{
				W1.Close();
			}	
			
		}
		
	}
	
	return 1;
}



int Click_W2(const Position &p)
{

	int k;

	for(k=0;k<14;k++)
	{
	
		if(Image_W2[k].IsInside(p))
		{
		
			if(k!=11&&k!=13&&k!=12)
			{
				output_W2[abc]=output_W2[abc]+name1_W2[k];
				W2.Erase(Position(1.5,7),8,0.5);
				W2.RenderText(Position(1.5,7),Position(9,7.5),output_W2[abc]);
				size1_W2[i]=size_W2[k];
			}
			
			
			else if(k==11&&output_W2[0]!="")
			{
			
				if(output_W2[1]==""&&flag==1)
				{
					abc=0;
					W2.RenderText(Position(1.5,7),Position(9,7.5),output_W2[abc]);
					flag=0;
				}

				else
				{
					output_W2[abc].erase(output_W2[abc].end()-1,output_W2[abc].end());
					W2.Erase(Position(1.5,7),8,0.5);
					W2.RenderText(Position(1.5,7),Position(9,7.5),output_W2[abc]);
				}
				
			}
			
			
			else if(k==13)
			{
				W2.Close();
				OpenW4();
				OpenW3();
			}
			
			
			else if(k==12)
			{
			
				if(flag==0)
				{
					abc++;
					W2.Erase(Position(1.5,7),8,0.5);
					flag=1;
				}
				
			}
			
		}
		
	}

	return 1;
}

int Click_W4(const Position &p)
{

	if(New.IsInside(p))
	{
		W4.Close();
		W3.Close();
		OpenW2();
	}

	if(Exit.IsInside(p))
	{
		W4.Close();
		W3.Close();
	}
	
}


//-------------------------/Click Functions---------------------


//-------------------------Parsing Function---------------------


double f(string str,float x,float y)
{
	FunctionParser fpar;
	fpar.AddConstant("pi",3.141592653);
	fpar.AddConstant("e",2.718281828);
	fpar.Parse(str,"x,y");
	double vars[]={x,y};
	double ans=fpar.Eval(vars);
	return ans;
}


//-------------------------/Parsing Function--------------------



//------------------------Extremas------------------------------

//Not Evaluated anywhere

int Extrema(string STR,float x,float y)
{
	double h=0.000001,lmt=0.000001;int j=0,A;
	//Partial df/dx
	float der_x=(f(STR,x+h,y)-f(STR,x,y))/h;
	//Partial df/dy
	float der_y=(f(STR,x,y+h)-f(STR,x,y))/h;
	//Partial d2f/dx2
	float double_der_x=(f(STR,x+2*h,y)-2*f(STR,x+h,y)+f(STR,x,y))/(h*h);
	//Partial d2f/dy2
	float double_der_y=(((f(STR,x,y+2*h)-f(STR,x,y+h))/h)-((f(STR,x,y+h)-f(STR,x,y))/h))/h;
	//Partial d2f/dxdy
	float double_der_xy=(((f(STR,x+h,y+h)-f(STR,x+h,y))/h)-((f(STR,x,y+h)-f(STR,x,y))/h))/h;
	//Discriminant
	float discr=((double_der_x)*(double_der_y))-((double_der_xy)*(double_der_xy));
	if(abs(der_x)<lmt&&abs(der_y)<lmt)//condition for a critical point
	{
		if(discr<0)
		{
			A=3;//saddle point
		}
		else 
		{
			if(double_der_x>0)
			{
				A=2;//minima
			}
			else A=1;//maxima
		}	
	}
	else A=0;
	return A;
}

//------------------------/Extremas------------------------------


